diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index e56bd181f..fa3bdb76e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -112,12 +112,6 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
         return false;
     }
 
-    @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        int sideId = side.getId();
-        return atlasIndices[sideId];
-    }
     protected boolean shouldFlipTexture(Side side, int meta){
         if(side == Side.TOP || side == Side.BOTTOM) return false;
         int state = block.getLogic().getRotation(meta);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
index a99cc6e5c..f15b2aa0a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
@@ -40,13 +40,8 @@ public class BlockModelFarmland<T extends BlockLogic> extends BlockModelStandard
             if (isWet) {
                 return mud;
             }
-            return atlasIndices[side.getId()];
+            return super.getBlockTextureFromSideAndMetadata(side, data);
         }
     }
 
-    @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side) {
-        if (side >= 2 && blockAccess.getBlockId(x, y, z) == block.id()) return false;
-        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index e47a6c138..411126ea4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -69,8 +69,8 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(data);
         if (side == dir.getSide()) {
-            return atlasIndices[Side.TOP.getId()];
+            return blockTextures.get(Side.TOP);
         }
-        return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
+        return side.getDirection() != dir.getOpposite() ? blockTextures.get(Side.NORTH) : blockTextures.get(Side.BOTTOM);
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
index d512b8726..a1f862167 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
@@ -20,9 +20,9 @@ public class BlockModelFurnace<T extends BlockLogic>
     public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
         int data = blockAccess.getBlockMetadata(x, y, z);
         int index = Sides.orientationLookUpHorizontal[6 * Math.min(data, 5) + side.getId()];
-        if (index >= Sides.orientationLookUpHorizontal.length) return atlasIndices[0];
+        if (index >= Sides.orientationLookUpHorizontal.length) return blockTextures.get(Side.BOTTOM);
         if (index == Side.NORTH.getId()) {
-            IconCoordinate originalFront = atlasIndices[index];
+            IconCoordinate originalFront = blockTextures.get(Side.NORTH);
             Container container = (Container) blockAccess.getBlockEntity(x, y, z);
             if (container != null) {
                 boolean hasOutput = container.getItem(2) != null;
@@ -32,6 +32,6 @@ public class BlockModelFurnace<T extends BlockLogic>
             }
             return originalFront;
         }
-        return atlasIndices[index];
+        return blockTextures.get(Side.getSideById(index));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
index 862c7b768..6c36c8811 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
@@ -32,8 +32,8 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         AABB bounds = block.getBounds();
-        boolean didRender = renderStandardBlock(tessellator, bounds, x, y, z);
-        if (RenderBlocks.fancyGrass){
+        boolean didRender = isRetro() ? renderStandardBlock(tessellator, bounds, x, y, z, 1, 1, 1) : renderStandardBlock(tessellator, bounds, x, y, z);
+        if (RenderBlocks.fancyGrass && !(retroBlockTextures.hasTexture() && isRetro())){
             useOverlay = true;
             didRender |= renderStandardBlock(tessellator, bounds, x, y, z);
             useOverlay = false;
@@ -71,7 +71,7 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.draw();
-        if(renderBlocks.useInventoryTint)
+        if(renderBlocks.useInventoryTint && !isRetro())
         {
             int l = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
             float f4 = (float)(l >> 16 & 0xff) / 255F;
@@ -83,7 +83,7 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
         tessellator.draw();
-        if (RenderBlocks.fancyGrass){
+        if (RenderBlocks.fancyGrass && !isRetro()){
             useOverlay = true;
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
@@ -119,7 +119,7 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
         if (useOverlay){
             return overlayIndices[side.getId()];
         }
-        return atlasIndices[side.getId()];
+        return super.getBlockTextureFromSideAndMetadata(side, data);
     }
     @Override
     public boolean shouldSideBeColored(WorldSource blockAccess, int x, int y, int z, int side, int meta){
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
index fe338966d..ce5d2d110 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
@@ -12,11 +12,18 @@ public class BlockModelHorizontalRotation<T extends BlockLogic> extends BlockMod
         super(block);
     }
 
+    @Override
+    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.getId()];
+        if (index >= Sides.orientationLookUpHorizontal.length) return overbrightTextures.get(Side.BOTTOM);
+        return super.getBlockOverbrightTextureFromSideAndMeta(Side.getSideById(index), data);
+    }
+
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.getId()];
-        if (index >= Sides.orientationLookUpHorizontal.length) return atlasIndices[0];
-        return atlasIndices[index];
+        if (index >= Sides.orientationLookUpHorizontal.length) return blockTextures.get(Side.BOTTOM);
+        return super.getBlockTextureFromSideAndMetadata(Side.getSideById(index), data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index f5f5a7ed9..c155b498d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -7,25 +8,55 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T> {
     protected static boolean fancyGraphics;
     protected final IconCoordinate fancyLeavesTexture;
+    protected final boolean canBeRetro;
+
+    protected final IconCoordinate retroLeaves = TextureRegistry.getTexture("minecraft:block/leaves/oak_retro");
+    protected final IconCoordinate retroLeavesFancy = TextureRegistry.getTexture("minecraft:block/leaves/oak_retro_fancy");
 
     public BlockModelLeaves(Block<T> block, String leavesTex) {
+        this(block, leavesTex, false);
+    }
+
+    public BlockModelLeaves(Block<T> block, String leavesTex, boolean canBeRetro) {
         super(block);
-        withTextures(leavesTex);
+        setAllTextures(BLOCK_TEXTURES, leavesTex);
         fancyLeavesTexture = TextureRegistry.getTexture(leavesTex + "_fancy");
+        this.canBeRetro = canBeRetro;
     }
 
     public static void setGraphicsLevel(boolean graphicsLevel)
     {
         fancyGraphics = graphicsLevel;
     }
+
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        boolean invTint = renderBlocks.useInventoryTint;
+        renderBlocks.useInventoryTint = (canBeRetro && isRetro());
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        renderBlocks.useInventoryTint = invTint;
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        if (canBeRetro && isRetro()) {
+            return renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z, 1, 1, 1);
+        }
+        return super.render(tessellator, x, y, z);
+    }
+
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return fancyGraphics ? fancyLeavesTexture : atlasIndices[side.getId()];
+        if (canBeRetro && isRetro()) {
+            return fancyGraphics ? retroLeavesFancy : retroLeaves;
+        }
+        return fancyGraphics ? fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
     }
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index 0ae4bffe9..a81cd0632 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -165,7 +165,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
         Direction direction = BlockLogicPistonBase.getDirection(data);
         if (direction == Direction.NONE)
         {
-            return atlasIndices[0];
+            return blockTextures.get(Side.BOTTOM);
         }
         if (side.getDirection() == direction)
         {
@@ -175,7 +175,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
             }
             else
             {
-                return atlasIndices[0];
+                return blockTextures.get(Side.BOTTOM);
             }
         }
         return side.getDirection() != direction.getOpposite() ? sideTexture : bottomTexture;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index ffb05a58e..23b3375e5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -19,7 +19,11 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
 
     public BlockModelRail(Block<T> block) {
         super(block);
-        this.hasOverbright = true;
+    }
+
+    @Override
+    public boolean hasOverbright() {
+        return true;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
index 53d1eb180..16cf2cce7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
@@ -15,6 +15,6 @@ public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandar
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int index = Sides.orientationLookUp[6 * data + side.getId()];
-        return atlasIndices[index];
+        return blockTextures.get(Side.getSideById(index));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
index 6ec38e54c..483bf3a65 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
@@ -7,25 +7,30 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelSlab<T extends BlockLogicSlab> extends BlockModelStandard<T> {
+    protected BlockModelStandard<T> parentModel;
     public BlockModelSlab(Block<T> block){
         super(block);
-        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock)).atlasIndices;
+        parentModel = (BlockModelStandard<T>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
+        blockTextures.copy(parentModel.blockTextures);
+        overbrightTextures.copy(parentModel.overbrightTextures);
+        retroBlockTextures.copy(parentModel.retroBlockTextures);
+        retroOverbrightTextures.copy(parentModel.retroOverbrightTextures);
         withCustomItemBounds(0, 0, 0, 1, 0.5d, 1);
     }
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
+        return parentModel.getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
     }
 
     @Override
     public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
+        return parentModel.getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
     }
 
     @Override
     public int renderLayer() {
-        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).renderLayer();
+        return parentModel.renderLayer();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
index 84aca82a7..cd9b156d6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
@@ -26,6 +26,6 @@ public class BlockModelSlabMarble<T extends BlockLogicSlab> extends BlockModelSl
         {
             return slabSide;
         }
-        return atlasIndices[side.getId()];
+        return super.getBlockTextureFromSideAndMetadata(side, data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 1ba715e77..563d440dd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -12,9 +12,14 @@ import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStandard<T> {
+    protected BlockModelStandard<T> parentModel;
     public BlockModelStairs(Block<T> block) {
         super(block);
-        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock)).atlasIndices;
+        parentModel = (BlockModelStandard<T>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
+        blockTextures.copy(parentModel.blockTextures);
+        overbrightTextures.copy(parentModel.overbrightTextures);
+        retroBlockTextures.copy(parentModel.retroBlockTextures);
+        retroOverbrightTextures.copy(parentModel.retroOverbrightTextures);
     }
 
     @Override
@@ -112,17 +117,17 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTextureFromSideAndMetadata(side, data);
+        return parentModel.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
     public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTexture(blockAccess, x, y, z, side);
+        return parentModel.getBlockTexture(blockAccess, x, y, z, side);
     }
 
     @Override
     public int renderLayer() {
-        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).renderLayer();
+        return parentModel.renderLayer();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index cefbbe29b..1601225cd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -10,16 +10,27 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
+import java.util.Arrays;
+
 public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
     public static final IconCoordinate BLOCK_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:block/texture_missing");
     public static final IconCoordinate BLOCK_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:block/texture_unassigned");
-    public IconCoordinate[] atlasIndices = new IconCoordinate[]{BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED};
-    public AABB itemRenderBounds = null;
-    public IconCoordinate overbrightTexture = null;
-    public int renderlayer = 0;
+    public @Nullable AABB itemRenderBounds = null;
+    public int renderLayer = 0;
+
+    public static final int BLOCK_TEXTURES = 0;
+    public static final int OVERBRIGHT_TEXTURES = 1;
+    public static final int RETRO_BLOCK_TEXTURES = 2;
+    public static final int RETRO_OVERBRIGHT_TEXTURES = 3;
+
+    protected final TextureLayer blockTextures = new TextureLayer().setAll(BLOCK_TEXTURE_UNASSIGNED);
+    protected final TextureLayer overbrightTextures = new TextureLayer();
+    protected final TextureLayer retroBlockTextures = new TextureLayer();
+    protected final TextureLayer retroOverbrightTextures = new TextureLayer();
 
     public BlockModelStandard(Block<T> block) {
         super(block);
@@ -139,15 +150,26 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
         return getBlockOverbrightTextureFromSideAndMeta(Side.getSideById(side), blockAccess.getBlockMetadata(x, y, z));
     }
 
+    @Override
+    public boolean hasOverbright() {
+        return overbrightTextures.hasTexture();
+    }
+
     @Override
     public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
-        return overbrightTexture;
+        if (retroOverbrightTextures.hasTexture && isRetro()) {
+            return retroOverbrightTextures.get(side);
+        }
+        return overbrightTextures.get(side);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return atlasIndices[side.getId()];
+        if (retroBlockTextures.hasTexture && isRetro()) {
+            return retroBlockTextures.get(side);
+        }
+        return blockTextures.get(side);
     }
     @Override
     public IconCoordinate getParticleTexture(Side side, int meta){
@@ -206,11 +228,11 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
 
     @Override
     public int renderLayer() {
-        return renderlayer;
+        return renderLayer;
     }
 
     public BlockModelStandard<T> onRenderLayer(int layer) {
-        this.renderlayer = layer;
+        this.renderLayer = layer;
         return this;
     }
 
@@ -218,28 +240,169 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
         this.itemRenderBounds = AABB.getPermanentBB(minX, minY, minZ, maxX, maxY, maxZ);
         return this;
     }
+
+    public BlockModelStandard<T> setTex(int layer, @Nullable IconCoordinate coordinate, Side ... sides) {
+        switch (layer) {
+            case BLOCK_TEXTURES:
+                blockTextures.set(coordinate, sides);
+                break;
+            case OVERBRIGHT_TEXTURES:
+                overbrightTextures.set(coordinate, sides);
+                break;
+            case RETRO_BLOCK_TEXTURES:
+                retroBlockTextures.set(coordinate, sides);
+                break;
+            case RETRO_OVERBRIGHT_TEXTURES:
+                retroOverbrightTextures.set(coordinate, sides);
+                break;
+        }
+        return this;
+    }
+
+    public BlockModelStandard<T> setTex(int layer, @Nullable String texture, Side ... sides) {
+        switch (layer) {
+            case BLOCK_TEXTURES:
+                blockTextures.set(texture, sides);
+                break;
+            case OVERBRIGHT_TEXTURES:
+                overbrightTextures.set(texture, sides);
+                break;
+            case RETRO_BLOCK_TEXTURES:
+                retroBlockTextures.set(texture, sides);
+                break;
+            case RETRO_OVERBRIGHT_TEXTURES:
+                retroOverbrightTextures.set(texture, sides);
+                break;
+        }
+        return this;
+    }
+
+    public BlockModelStandard<T> setAllTextures(int layer, @Nullable IconCoordinate coordinate) {
+        switch (layer) {
+            case BLOCK_TEXTURES:
+                blockTextures.setAll(coordinate);
+                break;
+            case OVERBRIGHT_TEXTURES:
+                overbrightTextures.setAll(coordinate);
+                break;
+            case RETRO_BLOCK_TEXTURES:
+                retroBlockTextures.setAll(coordinate);
+                break;
+            case RETRO_OVERBRIGHT_TEXTURES:
+                retroOverbrightTextures.setAll(coordinate);
+                break;
+        }
+        return this;
+    }
+
+    public BlockModelStandard<T> setAllTextures(int layer, @Nullable String texture) {
+        switch (layer) {
+            case BLOCK_TEXTURES:
+                blockTextures.setAll(texture);
+                break;
+            case OVERBRIGHT_TEXTURES:
+                overbrightTextures.setAll(texture);
+                break;
+            case RETRO_BLOCK_TEXTURES:
+                retroBlockTextures.setAll(texture);
+                break;
+            case RETRO_OVERBRIGHT_TEXTURES:
+                retroOverbrightTextures.setAll(texture);
+                break;
+        }
+        return this;
+    }
+
+
+    @Deprecated
     public BlockModelStandard<T> withOverbrightTexture(String texture)
     {
-        this.hasOverbright = true;
-        this.overbrightTexture = TextureRegistry.getTexture(texture);
+        overbrightTextures.setAll(texture);
         return this;
     }
+    @Deprecated
     public BlockModelStandard<T> withTextures(String texture){
-        return withTextures(texture, texture, texture);
+        blockTextures.setAll(texture);
+        return this;
     }
+    @Deprecated
     public BlockModelStandard<T> withTextures(String textureTopBottom, String textureSides){
-        return withTextures(textureTopBottom, textureTopBottom, textureSides);
+        blockTextures
+            .set(textureTopBottom, Side.TOP, Side.BOTTOM)
+            .set(textureSides, Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST);
+        return this;
     }
+    @Deprecated
     public BlockModelStandard<T> withTextures(String textureTop, String textureBottom, String textureSides){
-        return withTextures(textureTop, textureBottom, textureSides, textureSides, textureSides, textureSides);
+        blockTextures
+            .set(textureTop, Side.TOP)
+            .set(textureBottom, Side.BOTTOM)
+            .set(textureSides, Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST);
+        return this;
     }
+    @Deprecated
     public BlockModelStandard<T> withTextures(String textureTop, String textureBottom, String textureNorth, String textureEast, String textureSouth, String textureWest){
-        atlasIndices[Side.TOP.getId()] = TextureRegistry.getTexture(textureTop);
-        atlasIndices[Side.BOTTOM.getId()] = TextureRegistry.getTexture(textureBottom);
-        atlasIndices[Side.NORTH.getId()] = TextureRegistry.getTexture(textureNorth);
-        atlasIndices[Side.EAST.getId()] = TextureRegistry.getTexture(textureEast);
-        atlasIndices[Side.SOUTH.getId()] = TextureRegistry.getTexture(textureSouth);
-        atlasIndices[Side.WEST.getId()] = TextureRegistry.getTexture(textureWest);
+        blockTextures
+            .set(textureTop, Side.TOP)
+            .set(textureBottom, Side.BOTTOM)
+            .set(textureNorth, Side.NORTH)
+            .set(textureEast, Side.EAST)
+            .set(textureSouth, Side.SOUTH)
+            .set(textureWest, Side.WEST);
         return this;
     }
+
+    protected static class TextureLayer {
+        private final @Nullable IconCoordinate @NotNull [] coordinates = new IconCoordinate[6];
+        private boolean hasTexture = false;
+
+        public TextureLayer set(@Nullable IconCoordinate coordinate, Side ... sides) {
+            for (Side s : sides) {
+                assert s != Side.NONE : "Cannot set texture on a 'NONE' side!";
+                coordinates[s.getId()] = coordinate;
+            }
+
+            hasTexture = false;
+            for (int i = 0, coordinatesLength = coordinates.length; i < coordinatesLength; i++) {
+                IconCoordinate iconCoordinate = coordinates[i];
+                hasTexture |= iconCoordinate != null;
+            }
+            return this;
+        }
+
+        public TextureLayer set(@Nullable String texture, Side ... sides) {
+            return set(texture == null ? null : TextureRegistry.getTexture(texture), sides);
+        }
+
+        public TextureLayer setAll(@Nullable IconCoordinate coordinate) {
+            Arrays.fill(coordinates, coordinate);
+            hasTexture = coordinate != null;
+            return this;
+        }
+
+        public TextureLayer setAll(@Nullable String texture) {
+            return setAll(texture == null ? null : TextureRegistry.getTexture(texture));
+        }
+
+        public TextureLayer copy(@NotNull TextureLayer layer) {
+            System.arraycopy(layer.coordinates, 0, coordinates, 0, 6);
+            this.hasTexture = layer.hasTexture;
+            return this;
+        }
+
+        public @Nullable IconCoordinate get(@NotNull Side side) {
+            assert side != Side.NONE : "Cannot set texture on a 'NONE' side!";
+            return coordinates[side.getId()];
+        }
+
+        public @Nullable IconCoordinate get(int index) {
+            assert index >= 0 : "Index must be greater then or equal to 0!";
+            assert index < coordinates.length : "Index must be less then " + coordinates.length + "!";
+            return coordinates[index];
+        }
+
+        public boolean hasTexture() {
+            return this.hasTexture;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
index c79309466..0b31ef818 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
@@ -27,6 +27,6 @@ public class BlockModelTorchRedstone<T extends BlockLogic> extends BlockModelTor
 
     @Override
     public IconCoordinate getParticleTexture(Side side, int meta) {
-        return atlasIndices[Side.NORTH.getId()];
+        return blockTextures.get(Side.NORTH);
     }
 }
